package lsedit;

import java.awt.Graphics;
import java.util.*;

/* This routine seems to exist for only two reasons.
 * 1) It serves as a utility class for printing dotted lines
 * 2) It keeps track of edges that have been drawn to avoid redrawing them
 */

public class DrawCache extends Object 
{
	protected int edges = 0;
	protected int drawn = 0;

	protected Hashtable m_drawnCache;

	// --------------
	// Public methods
	// --------------

	public DrawCache(int numEntities, int numRelations) 
	{
		m_drawnCache = new Hashtable();
	}

	public boolean haveDrawn(EntityInstance vsrc, EntityInstance vdst, RelationClass rc) 
	{
		edges++;

		String str = Util.hashEdge(rc, vsrc, vdst);

		if (m_drawnCache.contains(str)) {
			return true;
		}
		m_drawnCache.put(str, str);
		drawn++;
		return false;
	}



	public void printStats() 
	{
		System.out.println("Edges: " + edges + " drawn: " + drawn);
	}

}

